/* 
 * This file is part of the Echo Point Project.  This project is a collection
 * of Components that have extended the Echo Web Application Framework.
 *
 * EchoPoint is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * EchoPoint is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo Point; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 *  JavaScript code for the Newsticker Component
 *
 *  This code has been borrowed in part from www.dynamicdrive.com
 */

var mapEchoPointTicker = new Array();

/*
 * 
 * The orientation should be "left", "right", "top", "bottom"
 *
 */
function EchoPointTicker(htmlId,contentHtmlId,scrollspeed,delay, orientation) {

	this.htmlId 		= htmlId;
	this.contentHtmlId	= contentHtmlId;
	this.scrollspeed	= scrollspeed;
	this.delay			= delay;
	this.speedcache		= scrollspeed;
	this.orientation	= orientation;
	this.contentMax 	= 0;
	this.marqueeMax   = 0;
	this.elmContent		= null;
	this.elmParent		= null;

	// functions
	this.initialize		= ept_initialize;
	this.scroll			= ept_scroll;
	mapEchoPointTicker[htmlId] = this;
}

//------------------------------------------
// Called to init the NewsTick once the document is loaded
//------------------------------------------
function ept_initialize(){
	this.elmContent = getElementById(this.contentHtmlId).htmlE;
	this.elmParent = getElementById(this.htmlId).htmlE;

	if (this.orientation == 'top') {
		this.marqueeMax= this.elmParent.offsetHeight;
		this.contentMax=this.elmContent.offsetHeight;
		this.elmContent.style.top=this.marqueeMax;
	}
	if (this.orientation == 'bottom') {
		this.marqueeMax= this.elmParent.offsetHeight;
		this.contentMax=this.elmContent.offsetHeight;
		this.elmContent.style.top=-this.contentMax;
	}
	if (this.orientation == 'left') {
		this.marqueeMax= this.elmParent.offsetWidth;
		this.contentMax=this.elmContent.offsetWidth;
		this.elmContent.style.left=this.marqueeMax;
	}
	if (this.orientation == 'right') {
		this.marqueeMax= this.elmParent.offsetWidth;
		this.contentMax=this.elmContent.offsetWidth;
		this.elmContent.style.left=-this.contentMax;
	}
	this.scroll();
}


function ept_scroll(){
	if (this.orientation == 'top') {
		this.elmContent.style.top = parseInt(this.elmContent.style.top)-this.scrollspeed;
		if (parseInt(this.elmContent.style.top) < this.contentMax*(-1))
			this.elmContent.style.top=Math.min(this.marqueeMax,this.contentMax);
	}
	if (this.orientation == 'left') {
		this.elmContent.style.left = parseInt(this.elmContent.style.left)-this.scrollspeed;
		if (parseInt(this.elmContent.style.left) < this.contentMax*(-1))
			this.elmContent.style.left = Math.min(this.marqueeMax,this.contentMax);
	}
	if (this.orientation == 'right') {
		this.elmContent.style.left = parseInt(this.elmContent.style.left)+this.scrollspeed;
		if (parseInt(this.elmContent.style.left) > this.marqueeMax)
			this.elmContent.style.left = - this.contentMax;
	}
	if (this.orientation == 'bottom') {
		this.elmContent.style.top = parseInt(this.elmContent.style.top)+this.scrollspeed;
		if (parseInt(this.elmContent.style.top) > this.marqueeMax)
			this.elmContent.style.top = - this.contentMax;
	}
	setTimeout("g_ept_scroll('" + this.htmlId + "')",this.delay)
}


function g_ept_scroll(htmlId) {	var obj = mapEchoPointTicker[htmlId];
	if (obj != null)
		obj.scroll();
}	

function g_ept_stop(htmlId){
	var obj = mapEchoPointTicker[htmlId];
	if (obj != null)
		obj.scrollspeed = 0;
	
}

function g_ept_start(htmlId){
	var obj = mapEchoPointTicker[htmlId];
	if (obj != null)
		obj.scrollspeed = obj.speedcache;
}
