/* JobServer MYSQL Schema */

CREATE TABLE js_dbversion
(
 stTag varchar(64),
 dtEntered datetime 
 );

CREATE TABLE js_serial_tbl
(
 type integer not null,
 maxid integer not null
 );

CREATE TABLE js_lock_tbl
(
 type integer not null,
 val integer not null
 );

/* SOAFaces jar expander */
INSERT INTO js_lock_tbl VALUES (1, 1);
/* JS Instance mutex */
INSERT INTO js_lock_tbl VALUES (2, 2);
/* aux 1 */
INSERT INTO js_lock_tbl VALUES (3, 3);
 /* aux 2 */
INSERT INTO js_lock_tbl VALUES (4, 4);
/* aux 3 */
INSERT INTO js_lock_tbl VALUES (5, 5); 

CREATE TABLE js_syscheck
(
 stHostname varchar(64) not null,
 dtTime bigint
 );

INSERT INTO js_syscheck (sthostname) VALUES ('empty');

CREATE TABLE js_systemprops
(
 stMailServer varchar(64),
 stReplyToAlertAddress varchar(64),
 stSysAlertAddresses varchar(255),
 stJobAlertAddresses varchar(255),
 stTimeZone varchar(128) DEFAULT '',
 bMuleServerEnabled integer DEFAULT 0, /* 1 true, 0 false */
 bSchedPerPartition integer DEFAULT 0,
 bSchedSharedDB integer DEFAULT 1,
 iSchedDefaultThreadSize integer DEFAULT 2,
 stCurrentSchedServer varchar(64) null,
 stMailServerUser varchar(32),
 stMailServerPass varchar(128),
 iMailPort integer DEFAULT -1, /* -1 use default */
 tMailSecurity integer DEFAULT 0 /* 0 none, 1 SSL, 2 TLS */
 );

INSERT INTO js_systemprops VALUES (NULL,NULL,NULL,NULL,'',0,0,0,2,NULL,NULL,NULL,-1,0);

CREATE TABLE js_systeminfo
(
 stInstanceDisplayName varchar(64),
 stSystemSyncTag char(32),
 dtSystemSyncTagCreate datetime,
 dtSystemSyncTagUpdate datetime
 );

INSERT INTO js_systeminfo VALUES ('give_me_a_name',NULL,CURRENT_TIMESTAMP,CURRENT_TIMESTAMP);

INSERT INTO js_serial_tbl (type,maxid) VALUES (1, 0);
INSERT INTO js_serial_tbl (type,maxid) VALUES (2, 0);
INSERT INTO js_serial_tbl (type,maxid) VALUES (3, 0);
INSERT INTO js_serial_tbl (type,maxid) VALUES (4, 0);
INSERT INTO js_serial_tbl (type,maxid) VALUES (5, 0);
INSERT INTO js_serial_tbl (type,maxid) VALUES (6, 1);
INSERT INTO js_serial_tbl (type,maxid) VALUES (7, 1);
/* node id */
INSERT INTO js_serial_tbl (type,maxid) VALUES (8, 0);
/* node run id */
INSERT INTO js_serial_tbl (type,maxid) VALUES (9, 0); 

CREATE TABLE js_jobdate 
(
 idJob integer not null,  /* seq ref */
 idRec integer not null, /* sequence */
 dtSched datetime,
 dtExpire datetime,      /* expire date past scheduleddate */
 dtEffPrior datetime,
 dtEff datetime,
 tRecType integer DEFAULT 1,  /* 1 - custom, 2 - ex days, 3 - inc days, 4 - ex range, 5 - ex time range */
 tDaysWeek integer DEFAULT 1,

 CONSTRAINT js_jobdate_pk PRIMARY KEY (idJob, idRec)
 );

CREATE TABLE js_res_grp
(
 id integer not null, /* seq type 6 */
 stname varchar(32) not null,
 isize integer,
 ifreeze integer DEFAULT 1, /*  2 frozen, 1 thaw */
 ifreezelocal integer DEFAULT 1, /*  2 frozen, 1 thaw */
 ischedsize integer DEFAULT 2,
 ilocalschedsize integer DEFAULT 3,
 bUseRemoteAgents integer DEFAULT 2, /* 2 no, 1 yes */
 ischedenabled integer DEFAULT 1, /* 2 no, 1 yes */
 stJobAlertAddresses varchar(255),
 tExtJvmMode integer DEFAULT 0, /* 0 Ext/Local (default local), 2 local only, 3 Ext only */
 iExtJvmMaxMem integer DEFAULT -1, /* -1 means do not set max jvm */
 stOtherJvmOptions varchar(128) DEFAULT '',

 CONSTRAINT js_res_grp_pk PRIMARY KEY (id),
 CONSTRAINT js_res_grp_unq UNIQUE (stname)
 );

INSERT INTO js_res_grp (id,stname,isize,ifreeze,ischedsize,ischedenabled,stjobalertaddresses,textjvmmode,iextjvmmaxmem,stotherjvmoptions)
                VALUES (1,'RootPartition',3,1,2,1,NULL,0,-1,'');

CREATE TABLE js_db_res
(
 id integer, /* should be a seq for rights enforcement */
 stname varchar(20),
 sturl varchar(255),
 stuser varchar(20),
 stpass varchar(20)
 );

CREATE TABLE js_job
(
 idJob integer not null, /* sequence */
 stName varchar(128) not null,
 stDescr varchar(255),
 tSched integer DEFAULT 1,
 tStatus integer DEFAULT 2, /* 1 pause, 2 stop, 3 active */
 iExpireval integer DEFAULT -1, /* seconds past next rundate to expire this, -1 none, -2 for custom interval */
 dtStart datetime not null,
 dtNext datetime,
 dtLast datetime,
 iresourcegrp integer DEFAULT 1,
 idJobGroup integer DEFAULT 1,
 iChoose integer DEFAULT 1,
 iField0 bigint DEFAULT -1,
 iField1 bigint DEFAULT -1,
 iField2 bigint DEFAULT -1,
 iField3 bigint DEFAULT -1,
 dtEndBy datetime,
 iEffOffset integer DEFAULT 0, /* -1 means use custom dates field */
 iPriorEffOffset integer DEFAULT 0,
 iSchedMax integer DEFAULT -1,
 iSchedCounter integer DEFAULT 0,
 iSchedTotal integer DEFAULT 0,
 tRelative integer DEFAULT 1,
 tSkip integer DEFAULT 2,
 stdepend1 varchar(64),
 stdepend2 varchar(64),
 stdepend3 varchar(64),
 stAlertAddresses varchar(255),
 ipriority integer,
 iworktype integer DEFAULT 1,
 ijobschedenabled integer DEFAULT 2,
 ijobrunmode integer DEFAULT 1,
 iapplaunchenabled integer DEFAULT 1,
 tOneAtTime integer DEFAULT 1,
 tExpireLogging integer DEFAULT 2,
 tExtJvmMode integer DEFAULT 1, /* 1 local, 2 Ext */
 iExtJvmMaxMem integer DEFAULT -1, /* -1 means do not specify max jvm */
 tExtJvmUseMuleLoader integer DEFAULT 1,
 tExtJvmUseContListener integer DEFAULT 1,
 tRetired integer DEFAULT 1,
 tRetryConfig integer DEFAULT 0, /* 0 no retry, 1 retry from last incomplete tasklet, 2 retry from start - v2.4.0 */
 iRetryLimit integer DEFAULT 0, /* 0 or less means unlimited - v2.4.0 */

 CONSTRAINT js_job_pk PRIMARY KEY (idJob)
 );

CREATE TABLE js_jobbean
(
 id integer not null, /* sequence */
 idJob integer not null,  /* seq ref */
 stType varchar(255),
 stJarname varchar(255),
 stName varchar(128), /* must be unique in job */
 stDescr varchar(255),
 iBeanseq integer not null,
 tErrordep integer DEFAULT 2, /* 1 means job stops execution if OperationException, 2 job continutes if OperationExeption */
 tInputtype integer DEFAULT 1, /* 1 none, 2 before only, 3 all tasks, 4 custom */
 tBlob integer DEFAULT 1, /* 1 means blob present, 2 otherwise */
 bEnabled integer not null, /* 1 is active, 2 is inactive */ 
 tIOSave integer DEFAULT 1, /* 1 no saving, 2 save output only, 3 save input only, 4 save both */
 stEndPoints varchar(255) DEFAULT '',
 stHtmlInject varchar(255) DEFAULT '',
 bUseMuleApi integer DEFAULT 2, /* 1 is active, 2 is inactive */
 tThreadJoin integer DEFAULT 0, /* 0 use sys default, 1 yes join, 2 no join - v2.4.0 */

 CONSTRAINT js_jobbean_pk PRIMARY KEY (idjob, id)
 );

/* list of prior beans that should be referenced */
/* Every operation will have one record for every operation before it */
CREATE TABLE js_op_bean_link
(
 idwb integer not null,
 idopin integer not null,  /* internal id */
 idopout integer not null, /*  multiple relationships to internal id */
 dep integer DEFAULT 2      /* if 1 ALL props are read from output bean and mapped with */
 );

CREATE TABLE js_op_prop_link
(
 idwb integer not null,
 idopin integer not null, /* internal id */
 idopout integer not null, /*  multiple relationships to internal id */
 inname varchar(255) not null,
 outname varchar(255) not null
 );

CREATE TABLE js_persqueue 
(
 idrun integer not null, /* sequence  seq_wbstatus */
 iBlob integer DEFAULT 1, /* 1 means blob present, 2 otherwise */
 idjob integer,
 stname varchar(128),
 iresgrp integer,
 ipriority integer,
 iorigpriority integer,
 iorder integer not null,
 dtenterq datetime,
 ifreeze integer DEFAULT 1, /*  2 frozen, 1 thaw */

 CONSTRAINT js_persqueue_pk PRIMARY KEY (idRun)
 );

CREATE TABLE js_opstatus 
(
 idrun integer not null,
 idjob integer not null,
 idtask integer not null,
 sttaskname varchar(128) not null,
 dtenter datetime not null,
 dtexit datetime,
 iexitstatus integer DEFAULT 0, /* 0 running, 1 completed, 2 failure, 3 disabled, 4 never finished - cleaned up, 5 running pending approval */
 iExitReason integer DEFAULT 0, /* 0 NA, 1 normal, 2 exit user, 3 failure/continue, 4 failure/exit, 5 internal error exit */  
 ierror integer DEFAULT 0, /* updated when op finished running 1 means errors exist */
 iwarn integer DEFAULT 0, /* updated when op finishes running 1 means warnings exist */
 stfailmsg varchar(255),
 stVersion varchar(255) not null,
 tIOSave integer DEFAULT 1, /* 1 no saving, 2 save output only, 3 save input only, 4 save both */
 iUserExitValue integer,
 stUserExitMsg varchar(255) DEFAULT '',
 idNode integer DEFAULT -3, /* -1 is primary, -2 secondary, -3 not assigned yet */
 iBeanseq integer DEFAULT -1,
 tRetryJobConfig integer DEFAULT 0, /* 0 not job retry, 1 retry from last incomplete tasklet, 2 retry from start - v2.4.0 */
 tRetryTasklet integer DEFAULT 0, /* 0 not retry of any kind, 1 copied over from parent, 2 retried at least once - v2.4.0 */

 CONSTRAINT js_opstatus_pk PRIMARY KEY (idRun, idJob, idTask)
 );

CREATE TABLE js_wbstatus 
(
 idrun integer not null, /* sequence  seq_wbstatus */
 idjob integer not null,
 stuser varchar(32),
 dtrun bigint not null,
 dtsched bigint,
 dtenterq bigint,
 dtenterwp bigint,
 dtexitwp bigint,
 istatus integer not null, /* 1=scheduled, 2=forced, 3=extreme force, 4=scheduled but expired */
 iresgrp integer,  /* -1 if run using OneTimeJP */
 iexitstatus integer DEFAULT 0, /* 0 queued, 1 running, 2 completed, 3 failure in at least one task, 4 wb never finished - cleaned up, 5 running pending approval */
 iExitReason integer DEFAULT 0, /* 0 NA, 1 normal, 2 exit user, 3 failure/exit, 4 internal error exit */
 ierror integer DEFAULT 0, /* updated when any op finishes running 1 means errors exist */
 iwarn integer DEFAULT 0, /* updated when any op finishes running 1 means warnings exist */
 stfailmsg varchar(255),
 iUserExitValue integer,
 stUserExitMsg varchar(255) DEFAULT '',
 tJvmMode integer DEFAULT 0, /* 0 local/shared, 1 separate JVM, 2 isolates */
 idNode integer DEFAULT -3, /* -1 is primary, -2 secondary, -3 not assigned yet */
 stNodeName varchar(64),
 dtKillRequest bigint,
 stKillUser varchar(64),
 tRetryConfig integer DEFAULT 0, /* Retry config value when job was orig first run - 0 not job retry, 1 retry from last incomplete tasklet, 2 retry from start - v2.4.0 */
 idRunOrig integer DEFAULT -1, /* if positive means a retry run - v2.4.0 */

 CONSTRAINT js_wbstatus_pk PRIMARY KEY (idRun)
 );

CREATE TABLE js_engstatus 
(
 idrun integer not null,
 dtstart datetime not null,
 dtschedstart datetime,
 dtexit datetime,
 iexitstatus integer DEFAULT 0,  /* 0 running, 1 gracefully shutdown, 2 immediate shutdown, 3 crashed and cleanedup */
 ijprocstate integer DEFAULT 1,  /* 1 jp enabled, jp disabled 0 */
 ijschedstate integer DEFAULT 1,  /* 1 jsched enabled, jsched disabled 0 */
 sthostname varchar(64),
 imanualstart integer DEFAULT 1,  /* 1 manual, 0 auto/ws start */

 CONSTRAINT js_engstatus_pk PRIMARY KEY (idRun)
 );


CREATE TABLE js_runwbstate 
(
 idrun integer  not null,
 idwb integer  not null,
 sttaskname varchar(128),
 idop integer not null,
 stdescrip varchar(255),
 dtrequest datetime not null,
 dtexpire datetime, /* null means it never expires */
 stusername varchar(32),
 dtreply datetime,
 istatus integer DEFAULT 0 /* 0 pending, 1 approved, 2 rejected by approver, 3 terminiated by user, 4 expired and system cleanup */
 );

/* record must be deleted on approval and cleanup */
CREATE TABLE js_runwbdata
( 
 idrun integer not null
 /* data blob not null */
 );

CREATE TABLE js_juser
(
 stUserName varchar(32) not null,
 stPassword varchar(32) not null,
 bEnabled integer DEFAULT 1,  /* 1 enabled, 2 disabled */
 stLastName varchar(32),
 stFirstName varchar(32),
 stEmail varchar(64),
 stPhone varchar(16),
 bAllPartition integer DEFAULT 2, /* 1 yes, 2 no */
 bAllJobGroup integer DEFAULT 2,   /* 1 yes, 2 no */

 CONSTRAINT js_juser_pk PRIMARY KEY (stUserName)
 );

INSERT INTO js_juser (stUserName, stPassword,benabled,stlastname,stfirstname,stemail,stphone,ballpartition,balljobgroup)
              VALUES ('admin', '9a2a96d4e7907c6cd09c7f8cbfe013b9',1,NULL,NULL,NULL,NULL,2,2);

CREATE TABLE js_jobgroup
(
 id integer not null,
 stName varchar(32) not null,
 stDesc varchar(255), 
 stJobAlertAddresses varchar(255),

 CONSTRAINT js_jobgroup_pk PRIMARY KEY (id),
 CONSTRAINT js_jobgroup_unq UNIQUE (stname)
 );

INSERT INTO js_jobgroup (id, stname, stdesc, stjobalertaddresses) VALUES (1, 'DEFAULT', 'Default Group',NULL);

CREATE TABLE js_user_region
(
 stUsername varchar(32) not null,
 stRegionName varchar(32) not null,

 CONSTRAINT js_user_region_pk PRIMARY KEY (stUsername, stRegionName)
 );

CREATE TABLE js_user_jobgroup
(
 stUsername varchar(32) not null,
 idJobGroup integer not null,

 CONSTRAINT js_user_jobgroup_pk PRIMARY KEY (stUsername, idJobGroup)
 );

CREATE TABLE js_user_partition
(
 stUsername varchar(32) not null,
 idPartition integer not null,

 CONSTRAINT js_user_partition_pk PRIMARY KEY (stUsername, idPartition)
 );


CREATE TABLE js_depend
(
 stname varchar(64) not null,
 stDescr varchar(255),
 stType varchar(255),
 bsatisified integer DEFAULT 2, /* 1 yes, 2 no */
 dtstart datetime,
 dtend datetime,

 CONSTRAINT js_depend_pk PRIMARY KEY (stname)
 );

CREATE TABLE js_taudit
(
 stusername varchar(32) not null,
 dtAction datetime not null,
 tAction integer not null,
 stKey varchar(128),
 stDetail varchar(255)
 );

CREATE TABLE js_node_partition_rel
(
 idNode integer not null,
 idPartition integer not null,
 iSize integer DEFAULT 0,
 bActive integer DEFAULT 1, /* 1 yes, 2 no */

 CONSTRAINT js_node_partition_rel_pk PRIMARY KEY (idNode, idPartition)
);

CREATE TABLE js_node
(
 idnode integer not null,
 stname varchar(64) not null,
 sthostname varchar(128) not null,
 iport integer not null,
 bactive integer DEFAULT 1, /* 1 yes, 2 no */
 iJvmMaxMem integer DEFAULT -1, /* -1 means do not set max jvm */
 stOtherJvmOptions varchar(128) DEFAULT '',
 bNodeOnly integer DEFAULT 1, /* 1 yes, 2 no */
 bDeleteFlag integer DEFAULT 2, /* 1 yes, 2 no */
 dtTime datetime, /* heartbeat */
 bCleaned integer DEFAULT 2, /* 1 yes, 2 no for heartbeat */

 CONSTRAINT js_node_pk PRIMARY KEY (idNode),
 CONSTRAINT js_node_unq UNIQUE (sthostname)
);

CREATE TABLE js_nodestatus
(
 idrun integer not null,
 idnode integer not null,
 stname varchar(64) not null,
 sthostname varchar(128) not null,
 dtstart datetime not null,
 dtexit datetime,
 iexitstatus integer DEFAULT 0, /* 0 running, 1 gracefully shutdown, 2 immediate shutdown, 3 crashed and cleanedup */
 imanualstart integer DEFAULT 1, /* 1 manual, 0 auto/ws start */

 CONSTRAINT js_nodestatus_pk PRIMARY KEY (idrun)
 );


/* CREATE INDEX js_jobdate_idx ON js_jobdate (idjob); */
CREATE INDEX js_job_name_idx ON js_job (stname,idjob);
CREATE INDEX js_op_bean_link_idx ON js_op_bean_link (idwb);
CREATE INDEX js_op_prop_link_idx ON js_op_prop_link (idwb);
CREATE INDEX js_wbstatus_iexit_idx ON js_wbstatus (iexitstatus,idjob);
CREATE INDEX js_wbstatus_date_idx ON js_wbstatus (dtrun,idjob);
/* v2.4.0 */
CREATE INDEX js_wbstatus_orig_idx ON js_wbstatus (idrunorig);
CREATE INDEX js_wbstatus_res_date_idx ON js_wbstatus (iresgrp,dtrun,idjob);
CREATE INDEX js_engstatus_idx ON js_engstatus (dtStart);
CREATE INDEX js_taudit_idx ON js_taudit (dtAction);
CREATE INDEX js_nodestatus_idx ON js_nodestatus (dtStart);

GRANT SELECT ON js_dbversion TO @jobserveruser@;
GRANT UPDATE ON js_dbversion TO @jobserveruser@;
GRANT INSERT ON js_dbversion TO @jobserveruser@;
GRANT DELETE ON js_dbversion TO @jobserveruser@;

GRANT SELECT ON js_serial_tbl TO @jobserveruser@;
GRANT UPDATE ON js_serial_tbl TO @jobserveruser@;
GRANT INSERT ON js_serial_tbl TO @jobserveruser@;
GRANT DELETE ON js_serial_tbl TO @jobserveruser@;

GRANT SELECT ON js_systemprops TO @jobserveruser@;
GRANT UPDATE ON js_systemprops TO @jobserveruser@;
GRANT INSERT ON js_systemprops TO @jobserveruser@;
GRANT DELETE ON js_systemprops TO @jobserveruser@;

GRANT SELECT ON js_jobdate TO @jobserveruser@;
GRANT UPDATE ON js_jobdate TO @jobserveruser@;
GRANT INSERT ON js_jobdate TO @jobserveruser@;
GRANT DELETE ON js_jobdate TO @jobserveruser@;

GRANT SELECT ON js_res_grp TO @jobserveruser@;
GRANT UPDATE ON js_res_grp TO @jobserveruser@;
GRANT INSERT ON js_res_grp TO @jobserveruser@;
GRANT DELETE ON js_res_grp TO @jobserveruser@;

GRANT SELECT ON js_db_res TO @jobserveruser@;
GRANT UPDATE ON js_db_res TO @jobserveruser@;
GRANT INSERT ON js_db_res TO @jobserveruser@;
GRANT DELETE ON js_db_res TO @jobserveruser@;

GRANT SELECT ON js_job TO @jobserveruser@;
GRANT UPDATE ON js_job TO @jobserveruser@;
GRANT INSERT ON js_job TO @jobserveruser@;
GRANT DELETE ON js_job TO @jobserveruser@;

GRANT SELECT ON js_jobbean TO @jobserveruser@;
GRANT UPDATE ON js_jobbean TO @jobserveruser@;
GRANT INSERT ON js_jobbean TO @jobserveruser@;
GRANT DELETE ON js_jobbean TO @jobserveruser@;

GRANT SELECT ON js_op_bean_link TO @jobserveruser@;
GRANT UPDATE ON js_op_bean_link TO @jobserveruser@;
GRANT INSERT ON js_op_bean_link TO @jobserveruser@;
GRANT DELETE ON js_op_bean_link TO @jobserveruser@;

GRANT SELECT ON js_op_prop_link TO @jobserveruser@;
GRANT UPDATE ON js_op_prop_link TO @jobserveruser@;
GRANT INSERT ON js_op_prop_link TO @jobserveruser@;
GRANT DELETE ON js_op_prop_link TO @jobserveruser@;

GRANT SELECT ON js_persqueue TO @jobserveruser@;
GRANT UPDATE ON js_persqueue TO @jobserveruser@;
GRANT INSERT ON js_persqueue TO @jobserveruser@;
GRANT DELETE ON js_persqueue TO @jobserveruser@;

GRANT SELECT ON js_opstatus TO @jobserveruser@;
GRANT UPDATE ON js_opstatus TO @jobserveruser@;
GRANT INSERT ON js_opstatus TO @jobserveruser@;
GRANT DELETE ON js_opstatus TO @jobserveruser@;

GRANT SELECT ON js_wbstatus TO @jobserveruser@;
GRANT UPDATE ON js_wbstatus TO @jobserveruser@;
GRANT INSERT ON js_wbstatus TO @jobserveruser@;
GRANT DELETE ON js_wbstatus TO @jobserveruser@;

GRANT SELECT ON js_engstatus TO @jobserveruser@;
GRANT UPDATE ON js_engstatus TO @jobserveruser@;
GRANT INSERT ON js_engstatus TO @jobserveruser@;
GRANT DELETE ON js_engstatus TO @jobserveruser@;

GRANT SELECT ON js_runwbstate TO @jobserveruser@;
GRANT UPDATE ON js_runwbstate TO @jobserveruser@;
GRANT INSERT ON js_runwbstate TO @jobserveruser@;
GRANT DELETE ON js_runwbstate TO @jobserveruser@;

GRANT SELECT ON js_runwbdata TO @jobserveruser@;
GRANT UPDATE ON js_runwbdata TO @jobserveruser@;
GRANT INSERT ON js_runwbdata TO @jobserveruser@;
GRANT DELETE ON js_runwbdata TO @jobserveruser@;

GRANT SELECT ON js_juser TO @jobserveruser@;
GRANT UPDATE ON js_juser TO @jobserveruser@;
GRANT INSERT ON js_juser TO @jobserveruser@;
GRANT DELETE ON js_juser TO @jobserveruser@;

GRANT SELECT ON js_jobgroup TO @jobserveruser@;
GRANT UPDATE ON js_jobgroup TO @jobserveruser@;
GRANT INSERT ON js_jobgroup TO @jobserveruser@;
GRANT DELETE ON js_jobgroup TO @jobserveruser@;

GRANT SELECT ON js_user_region TO @jobserveruser@;
GRANT UPDATE ON js_user_region TO @jobserveruser@;
GRANT INSERT ON js_user_region TO @jobserveruser@;
GRANT DELETE ON js_user_region TO @jobserveruser@;

GRANT SELECT ON js_user_jobgroup TO @jobserveruser@;
GRANT UPDATE ON js_user_jobgroup TO @jobserveruser@;
GRANT INSERT ON js_user_jobgroup TO @jobserveruser@;
GRANT DELETE ON js_user_jobgroup TO @jobserveruser@;

GRANT SELECT ON js_user_partition TO @jobserveruser@;
GRANT UPDATE ON js_user_partition TO @jobserveruser@;
GRANT INSERT ON js_user_partition TO @jobserveruser@;
GRANT DELETE ON js_user_partition TO @jobserveruser@;

GRANT SELECT ON js_depend TO @jobserveruser@;
GRANT UPDATE ON js_depend TO @jobserveruser@;
GRANT INSERT ON js_depend TO @jobserveruser@;
GRANT DELETE ON js_depend TO @jobserveruser@;

GRANT SELECT ON js_taudit TO @jobserveruser@;
GRANT UPDATE ON js_taudit TO @jobserveruser@;
GRANT INSERT ON js_taudit TO @jobserveruser@;
GRANT DELETE ON js_taudit TO @jobserveruser@;

GRANT SELECT ON js_lock_tbl TO @jobserveruser@;
GRANT UPDATE ON js_lock_tbl TO @jobserveruser@;
GRANT INSERT ON js_lock_tbl TO @jobserveruser@;
GRANT DELETE ON js_lock_tbl TO @jobserveruser@;

GRANT SELECT ON js_syscheck TO @jobserveruser@;
GRANT UPDATE ON js_syscheck TO @jobserveruser@;
GRANT INSERT ON js_syscheck TO @jobserveruser@;
GRANT DELETE ON js_syscheck TO @jobserveruser@;

GRANT SELECT ON js_node_partition_rel TO @jobserveruser@;
GRANT UPDATE ON js_node_partition_rel TO @jobserveruser@;
GRANT INSERT ON js_node_partition_rel TO @jobserveruser@;
GRANT DELETE ON js_node_partition_rel TO @jobserveruser@;

GRANT SELECT ON js_node TO @jobserveruser@;
GRANT UPDATE ON js_node TO @jobserveruser@;
GRANT INSERT ON js_node TO @jobserveruser@;
GRANT DELETE ON js_node TO @jobserveruser@;

GRANT SELECT ON js_nodestatus TO @jobserveruser@;
GRANT UPDATE ON js_nodestatus TO @jobserveruser@;
GRANT INSERT ON js_nodestatus TO @jobserveruser@;
GRANT DELETE ON js_nodestatus TO @jobserveruser@;

GRANT SELECT ON js_systeminfo TO @jobserveruser@;
GRANT UPDATE ON js_systeminfo TO @jobserveruser@;
GRANT INSERT ON js_systeminfo TO @jobserveruser@;
GRANT DELETE ON js_systeminfo TO @jobserveruser@;