/* JobServer 3.0.0 sql for MYSQL database */

alter table js_jobdate add CONSTRAINT js_jobdate_pk PRIMARY KEY (idRec);
alter table js_res_grp add CONSTRAINT js_res_grp_pk PRIMARY KEY (id);
drop index js_job_idx;
alter table js_job add CONSTRAINT js_job_pk PRIMARY KEY (idJob);
drop index js_jobbean_idx;
alter table js_jobbean add CONSTRAINT js_jobbean_pk PRIMARY KEY (id);
DROP INDEX js_persqueue_idx;
alter table js_persqueue add CONSTRAINT js_persqueue_pk PRIMARY KEY (idRun);
drop index js_opstatus_idx;
alter table js_opstatus add CONSTRAINT js_opstatus_pk PRIMARY KEY (idRun);
drop index js_wbstatus_idx;
alter table js_wbstatus add CONSTRAINT js_wbstatus_pk PRIMARY KEY (idRun);
alter table js_engstatus add CONSTRAINT js_engstatus_pk PRIMARY KEY (idRun);
alter table js_juser add CONSTRAINT js_juser_pk PRIMARY KEY (stUserName);
alter table js_jobgroup add CONSTRAINT js_jobgroup_pk PRIMARY KEY (id);
alter table js_user_region add CONSTRAINT js_user_region_pk PRIMARY KEY (stUsername, stRegionName);
alter table js_user_jobgroup add CONSTRAINT js_user_jobgroup_pk PRIMARY KEY (stUsername, idJobGroup);
alter table js_user_partition add CONSTRAINT js_user_partition_pk PRIMARY KEY (stUsername, idPartition);
alter table js_depend add CONSTRAINT js_depend_pk PRIMARY KEY (stname);

/*******/

INSERT INTO js_serial_tbl (type,maxid) VALUES (8, 0);
INSERT INTO js_serial_tbl (type,maxid) VALUES (9, 0);
alter table js_res_grp add ifreezelocal integer DEFAULT 1;
alter table js_res_grp add ilocalschedsize integer DEFAULT 2;
alter table js_res_grp add bUseRemoteAgents integer DEFAULT 2;
alter table js_job add tRetired integer DEFAULT 1;
alter table js_opstatus add idNode integer DEFAULT -3;
alter table js_wbstatus add idNode integer DEFAULT -3;

CREATE TABLE js_node_partition_rel
(
 idNode integer not null,
 idPartition integer not null,
 iSize integer DEFAULT 0,
 bActive integer DEFAULT 1, /* 1 yes, 2 no */

 CONSTRAINT js_node_partition_rel_pk PRIMARY KEY (idNode, idPartition)
);

CREATE TABLE js_node
(
 idnode integer not null,
 stname varchar(64) not null,
 sthostname varchar(128) not null,
 iport integer not null,
 bactive integer DEFAULT 1, /* 1 yes, 2 no */
 iJvmMaxMem integer DEFAULT -1, /* -1 means do not set max jvm */
 stOtherJvmOptions varchar(128) DEFAULT '',
 bNodeOnly integer DEFAULT 1, /* 1 yes, 2 no */
 bDeleteFlag integer DEFAULT 2, /* 1 yes, 2 no */
 dtTime datetime, /* heartbeat */
 bCleaned integer DEFAULT 2, /* 1 yes, 2 no for heartbeat */

 CONSTRAINT js_node_pk PRIMARY KEY (idNode)
);

CREATE TABLE js_nodestatus
(
 idrun integer not null,
 idnode integer not null,
 stname varchar(64) not null,
 sthostname varchar(128) not null,
 dtstart datetime not null,
 dtexit datetime,
 iexitstatus integer DEFAULT 0, /* 0 running, 1 gracefully shutdown, 2 immediate shutdown, 3 crashed and cleanedup */
 imanualstart integer DEFAULT 1, /* 1 manual, 0 auto/ws start */

 CONSTRAINT js_nodestatus_pk PRIMARY KEY (idrun)
 );

CREATE INDEX js_nodestatus_idx ON js_nodestatus (dtStart);

GRANT SELECT ON js_node_partition_rel TO jsuser;
GRANT UPDATE ON js_node_partition_rel TO jsuser;
GRANT INSERT ON js_node_partition_rel TO jsuser;
GRANT DELETE ON js_node_partition_rel TO jsuser;

GRANT SELECT ON js_node TO jsuser;
GRANT UPDATE ON js_node TO jsuser;
GRANT INSERT ON js_node TO jsuser;
GRANT DELETE ON js_node TO jsuser;

GRANT SELECT ON js_nodestatus TO jsuser;
GRANT UPDATE ON js_nodestatus TO jsuser;
GRANT INSERT ON js_nodestatus TO jsuser;
GRANT DELETE ON js_nodestatus` TO jsuser;





